/*
 * File name: neuron.h
 * Date:      2013/10/13 09:02
 * Author:    Jan Faigl
 */

#ifndef __NEURON_H__
#define __NEURON_H__

namespace som {

   struct SNeuron {
      SNeuron* prev;
      SNeuron* next;
      Coords coords;
      Coords alternateGoal;
      int stationOnTourStep;
      int stationOnTour; 

      SNeuron() {
	 clear();
      }

      SNeuron(const Coords& pt) : coords(pt) {
	 clear();
      } 

      ~SNeuron() {
      }

      void setPoint(const Coords& pt) {
	 coords = pt;
	 clear();
      }

      void clear(void) { 
	 stationOnTour = -1;
	 stationOnTourStep = -1;
      }

      void adapt(const Coords& pt, const double beta) {
	 coords.x += beta * (pt.x - coords.x);
	 coords.y += beta * (pt.y - coords.y);
      }
      inline bool isInhibited(int step) { return stationOnTourStep >= step; }
   };

} //end namespace som

#endif

/* end of neuron.h */
